<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * OTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail StructType
 * @package Dg
 * @subpackage Structs
 */
class DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail extends AbstractStructBase
{
    /**
     * The StartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $StartDate;
    /**
     * The EndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $EndDate;
    /**
     * The RequiredDocumentType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RequiredDocumentType;
    /**
     * The PlanDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgFormattedTextType
     */
    public $PlanDescription;
    /**
     * The PlanRulesURL
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgURL_Type
     */
    public $PlanRulesURL;
    /**
     * The QuoteDetailURL
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgURL_Type
     */
    public $QuoteDetailURL;
    /**
     * The BookingDetailURL
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgURL_Type
     */
    public $BookingDetailURL;
    /**
     * The ParentProductName
     * @var string
     */
    public $ParentProductName;
    /**
     * The ParentProductCode
     * @var string
     */
    public $ParentProductCode;
    /**
     * Constructor method for
     * OTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setStartDate()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setEndDate()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setRequiredDocumentType()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setPlanDescription()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setPlanRulesURL()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setQuoteDetailURL()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setBookingDetailURL()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setParentProductName()
     * @uses DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail::setParentProductCode()
     * @param string $startDate
     * @param string $endDate
     * @param string $requiredDocumentType
     * @param \dgsoft\StructType\DgFormattedTextType $planDescription
     * @param \dgsoft\StructType\DgURL_Type $planRulesURL
     * @param \dgsoft\StructType\DgURL_Type $quoteDetailURL
     * @param \dgsoft\StructType\DgURL_Type $bookingDetailURL
     * @param string $parentProductName
     * @param string $parentProductCode
     */
    public function __construct($startDate = null, $endDate = null, $requiredDocumentType = null, \dgsoft\StructType\DgFormattedTextType $planDescription = null, \dgsoft\StructType\DgURL_Type $planRulesURL = null, \dgsoft\StructType\DgURL_Type $quoteDetailURL = null, \dgsoft\StructType\DgURL_Type $bookingDetailURL = null, $parentProductName = null, $parentProductCode = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setRequiredDocumentType($requiredDocumentType)
            ->setPlanDescription($planDescription)
            ->setPlanRulesURL($planRulesURL)
            ->setQuoteDetailURL($quoteDetailURL)
            ->setBookingDetailURL($bookingDetailURL)
            ->setParentProductName($parentProductName)
            ->setParentProductCode($parentProductCode);
    }
    /**
     * Get StartDate value
     * @return string
     */
    public function getStartDate()
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        return $this;
    }
    /**
     * Get EndDate value
     * @return string
     */
    public function getEndDate()
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        return $this;
    }
    /**
     * Get RequiredDocumentType value
     * @return string|null
     */
    public function getRequiredDocumentType()
    {
        return $this->RequiredDocumentType;
    }
    /**
     * Set RequiredDocumentType value
     * @param string $requiredDocumentType
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setRequiredDocumentType($requiredDocumentType = null)
    {
        // validation for constraint: string
        if (!is_null($requiredDocumentType) && !is_string($requiredDocumentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requiredDocumentType)), __LINE__);
        }
        $this->RequiredDocumentType = $requiredDocumentType;
        return $this;
    }
    /**
     * Get PlanDescription value
     * @return \dgsoft\StructType\DgFormattedTextType|null
     */
    public function getPlanDescription()
    {
        return $this->PlanDescription;
    }
    /**
     * Set PlanDescription value
     * @param \dgsoft\StructType\DgFormattedTextType $planDescription
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setPlanDescription(\dgsoft\StructType\DgFormattedTextType $planDescription = null)
    {
        $this->PlanDescription = $planDescription;
        return $this;
    }
    /**
     * Get PlanRulesURL value
     * @return \dgsoft\StructType\DgURL_Type|null
     */
    public function getPlanRulesURL()
    {
        return $this->PlanRulesURL;
    }
    /**
     * Set PlanRulesURL value
     * @param \dgsoft\StructType\DgURL_Type $planRulesURL
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setPlanRulesURL(\dgsoft\StructType\DgURL_Type $planRulesURL = null)
    {
        $this->PlanRulesURL = $planRulesURL;
        return $this;
    }
    /**
     * Get QuoteDetailURL value
     * @return \dgsoft\StructType\DgURL_Type|null
     */
    public function getQuoteDetailURL()
    {
        return $this->QuoteDetailURL;
    }
    /**
     * Set QuoteDetailURL value
     * @param \dgsoft\StructType\DgURL_Type $quoteDetailURL
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setQuoteDetailURL(\dgsoft\StructType\DgURL_Type $quoteDetailURL = null)
    {
        $this->QuoteDetailURL = $quoteDetailURL;
        return $this;
    }
    /**
     * Get BookingDetailURL value
     * @return \dgsoft\StructType\DgURL_Type|null
     */
    public function getBookingDetailURL()
    {
        return $this->BookingDetailURL;
    }
    /**
     * Set BookingDetailURL value
     * @param \dgsoft\StructType\DgURL_Type $bookingDetailURL
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setBookingDetailURL(\dgsoft\StructType\DgURL_Type $bookingDetailURL = null)
    {
        $this->BookingDetailURL = $bookingDetailURL;
        return $this;
    }
    /**
     * Get ParentProductName value
     * @return string|null
     */
    public function getParentProductName()
    {
        return $this->ParentProductName;
    }
    /**
     * Set ParentProductName value
     * @param string $parentProductName
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setParentProductName($parentProductName = null)
    {
        // validation for constraint: string
        if (!is_null($parentProductName) && !is_string($parentProductName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($parentProductName)), __LINE__);
        }
        $this->ParentProductName = $parentProductName;
        return $this;
    }
    /**
     * Get ParentProductCode value
     * @return string|null
     */
    public function getParentProductCode()
    {
        return $this->ParentProductCode;
    }
    /**
     * Set ParentProductCode value
     * @param string $parentProductCode
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public function setParentProductCode($parentProductCode = null)
    {
        // validation for constraint: string
        if (!is_null($parentProductCode) && !is_string($parentProductCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($parentProductCode)), __LINE__);
        }
        $this->ParentProductCode = $parentProductCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRSAvailablePlansAvailablePlanPlanDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
